/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.ergebnis.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.ergebnis.entity.Ergebnis;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractErgebnisSearch {

  @Inject
  protected transient ErgebnisExtendedDAO dao;

  public AbstractErgebnisSearch() {
    super();
  }

  public List<Ergebnis> getSearchResult(ErgebnisSearchParameters searchParameters, EagerLoadingCollector<Ergebnis> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<Ergebnis> querySearchResult(ErgebnisSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
